﻿Module CaricaCoolProp

    '///////////////////////////////////////////////////////////////////////////////////////////////////////
    'Carica dalla DLL di CoolProp le funzioni PropsSI, Props1SI, HAProps e ne consente l'uso in Visual Basic
    '////////////////////////////////////////////////////////////////////////////////////////////////////////
    'Questo modulo semplifica l'uso di CoolProp in qualsiasi applicazione Visual Basic
    'E' sufficiente copiare questo modulo e il file CoolProp.dll pari pari e inserirlo in una soluzione in Visual Basic.

    'Nota di Marco: Affinchè funzioni, la libreria CoolProp.dll deve essere caricata dove si trova il file eseguibile, altrimenti va aggiornato il percorso sotto
    '(di default ho messo ".\CoolProp.dll")
    'Inoltre, deve comparire tra i file in "Esplora soluzione"
    'Infine, la DLL deve essere impostata come "Azione di compilazione: Contenuto", "Copia nella directory: Copia sempre"
    Private Declare Function PropsSI_private Lib ".\CoolProp.dll" Alias "PropsSI" (ByVal ReturnValue As String, ByVal Name1 As String, ByVal Value1 As Double, ByVal Name2 As String, ByVal Value2 As Double, ByVal Ref As String) As Double
    Private Declare Function Props1SI_private Lib ".\CoolProp.dll" Alias "Props1SI" (ByVal Ref As String, ByVal ReturnValue As String) As Double
    Private Declare Function HAProps_private Lib ".\CoolProp.dll" Alias "HAProps" (ByVal ReturnValue As String, ByVal Input1Name As String, ByVal Value1 As Double, ByVal Input2Name As String, ByVal Value2 As Double, ByVal Input3name As String, ByVal Value3 As Double) As Double

    'Converte le tre funzioni dichiarate sopra in funzioni utilizzabili da Visual Basic
    'Per il significato delle funzioni e dei valori da inserire si rimanda all'help della libreria.
    Public Function PropsSI(ByVal ReturnValue As String, ByVal Name1 As String, ByVal Value1 As Double, ByVal Name2 As String, ByVal Value2 As Double, ByVal Ref As String) As Double
        PropsSI = PropsSI_private(ReturnValue, Name1, Value1, Name2, Value2, Ref)
    End Function

    Public Function Props1SI(ByVal Ref As String, ByVal ReturnValue As String) As Double
        Props1SI = Props1SI_private(Ref, ReturnValue)
    End Function

    Public Function HAProps(ByVal ReturnValue As String, ByVal Input1Name As String, ByVal Value1 As Double, ByVal Input2Name As String, ByVal Value2 As Double, ByVal Input3name As String, ByVal Value3 As Double) As Double
        HAProps = HAProps_private(ReturnValue, Input1Name, Value1, Input2Name, Value2, Input3name, Value3)
    End Function

End Module
